Unit qs21e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, FTF1P_p, UTQS12_p;

procedure qs21e(var U :Array of Extended; var V :Array of Extended;
                A :Extended; B :Extended; F :Proc_F3_Q; N :Integer;
                var IERR :Integer);

implementation

procedure qs21e(var U :Array of Extended; var V :Array of Extended;
                A :Extended; B :Extended; F :Proc_F3_Q; N :Integer;
                var IERR :Integer);
var
IN_,K,KK,N1,N2 :Integer;
D,D1,F1,F2,P,R1,R2,X :Extended;
const
NMAX :Integer = 1048576;
label
_10,_20,_30,_40,_50,_60,_70;
begin
IERR  := 0;
if ( N  =  0 ) 
 then goto _70;
if ( N  <=  NMAX ) 
 then goto _10;
IERR  := 65;
UTQS12(IERR,17);
goto _70;
_10:
D  := B - A;
D1  := D/N;
IN_  := 1;
KK  := 1;
P  := 1.e0;
N1  := N div 2;
N2  := N1 - 1;
for K:=1 to N do
 begin
  X  := A + (K - 1)*D1;
  F(X,F1,F2);
  U[K-1] := F1;
  V[K-1] := F2;
_20:
 end;
U[0] := U[0]/3.e0;
V[0] := V[0]/3.e0;
for K:=1 to N1 do
 begin
  U[2*K-1] := 4.e0*U[2*K-1]/3.e0;
  V[2*K-1] := 4.e0*V[2*K-1]/3.e0;
_30:
 end;
for K:=1 to N2 do
 begin
  U[2*K+0] := 2.e0*U[2*K+0]/3.e0;
  V[2*K+0] := 2.e0*V[2*K+0]/3.e0;
_40:
 end;
FTF1P(U,V,N,IN_,KK,P);
for K:=1 to N do
 begin
  U[K-1] := D1*U[K-1];
  V[K-1] := D1*V[K-1];
_50:
 end;
F(B,F1,F2);
R1  := F1/(3.e0*N);
R2  := F2/(3.e0*N);
for K:=1 to N do
 begin
  U[K-1] := U[K-1] + R1;
  V[K-1] := V[K-1] + R2;
_60:
 end;
_70:
end;

end.
